/* 

   Copyright 1994, 1995, 1996, 1997, 1998, 1999  by Bernie Roehl 

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA,
   02111-1307, USA.

   For more information, contact Bernie Roehl <broehl@uwaterloo.ca> 
   or at Bernie Roehl, 68 Margaret Avenue North, Waterloo, Ontario, 
   N2J 3P7, Canada

*/
#include "avril.h"
#include "avrildrv.h"
#include <stdlib.h>
#include <bios.h>

void main(int argc, char *argv[])
	{
	vrl_Device *d = vrl_DeviceOpen(vrl_7thSenseDevice, 0);
	if (d == NULL) { printf("Couldn't open device\n"); exit(1); }
	if (argc > 1) vrl_DeviceSetMode(d, atoi(argv[1]));
	vrl_TimerInit();
	while (!bioskey(1))
		{
		vrl_DevicePollAll();
		printf("%ld %ld %ld   %f %f %f  %d\n",
			vrl_DeviceGetValue(d, X),
			vrl_DeviceGetValue(d, Y),
			vrl_DeviceGetValue(d, Z),
			angle2float(vrl_DeviceGetValue(d, XROT)),
			angle2float(vrl_DeviceGetValue(d, YROT)),
			angle2float(vrl_DeviceGetValue(d, ZROT)),
			vrl_DeviceGetButtons(d));
		}
	bioskey(0);
	vrl_TimerQuit();
	vrl_DeviceCloseAll();
	}
